aboutsummaryrefslogtreecommitdiff
path: root/sh
diff options
context:
space:
mode:
Diffstat (limited to 'sh')
-rw-r--r--sh/Makefile4
-rw-r--r--sh/openrc-run.sh.in4
-rw-r--r--sh/runit.sh52
3 files changed, 58 insertions, 2 deletions
diff --git a/sh/Makefile b/sh/Makefile
index 24c23159..1af23ecd 100644
--- a/sh/Makefile
+++ b/sh/Makefile
@@ -1,8 +1,8 @@
DIR= ${LIBEXECDIR}/sh
SRCS= init.sh.in functions.sh.in gendepends.sh.in \
openrc-run.sh.in rc-functions.sh.in tmpfiles.sh.in ${SRCS-${OS}}
-INC= functions.sh rc-mount.sh rc-functions.sh s6.sh start-stop-daemon.sh \
- supervise-daemon.sh
+INC= rc-mount.sh functions.sh rc-functions.sh runit.sh s6.sh \
+ start-stop-daemon.sh supervise-daemon.sh
BIN= gendepends.sh init.sh openrc-run.sh tmpfiles.sh ${BIN-${OS}}
INSTALLAFTER= _installafter
diff --git a/sh/openrc-run.sh.in b/sh/openrc-run.sh.in
index 36bc3663..ce5432f8 100644
--- a/sh/openrc-run.sh.in
+++ b/sh/openrc-run.sh.in
@@ -153,6 +153,7 @@ start()
{
local func=ssd_start
case "$supervisor" in
+ runit) func=runit_start ;;
s6) func=s6_start ;;
supervise-daemon) func=supervise_start ;;
?*)
@@ -166,6 +167,7 @@ stop()
{
local func=ssd_stop
case "$supervisor" in
+ runit) func=runit_stop ;;
s6) func=s6_stop ;;
supervise-daemon) func=supervise_stop ;;
?*)
@@ -179,6 +181,7 @@ status()
{
local func=ssd_status
case "$supervisor" in
+ runit) func=runit_status ;;
s6) func=s6_status ;;
supervise-daemon) func=supervise_status ;;
?*)
@@ -216,6 +219,7 @@ fi
# load service supervisor functions
+sourcex "@LIBEXECDIR@/sh/runit.sh"
sourcex "@LIBEXECDIR@/sh/s6.sh"
sourcex "@LIBEXECDIR@/sh/start-stop-daemon.sh"
sourcex "@LIBEXECDIR@/sh/supervise-daemon.sh"
diff --git a/sh/runit.sh b/sh/runit.sh
new file mode 100644
index 00000000..e9c1d220
--- /dev/null
+++ b/sh/runit.sh
@@ -0,0 +1,52 @@
+# Copyright (c) 2016 The OpenRC Authors.
+# See the Authors file at the top-level directory of this distribution and
+# https://github.com/OpenRC/openrc/blob/master/AUTHORS
+#
+# This file is part of OpenRC. It is subject to the license terms in
+# the LICENSE file found in the top-level directory of this
+# distribution and at https://github.com/OpenRC/openrc/blob/master/LICENSE
+# This file may not be copied, modified, propagated, or distributed
+# except according to the terms contained in the LICENSE file.
+# Released under the 2-clause BSD license.
+
+runit_start()
+{
+ local service_path service_link
+ service_path="${runit_service:-/etc/sv/${RC_SVCNAME}}"
+ if [ ! -d "${service_path}" ]; then
+ eerror "Runit service ${service_path} not found"
+ return 1
+ fi
+ service_link="${RC_SVCDIR}/sv/${service_path##*/}"
+ ebegin "Starting ${name:-$RC_SVCNAME}"
+ ln -snf "${service_path}" "${service_link}"
+ sv start "${service_link}" > /dev/null 2>&1
+ eend $? "Failed to start $RC_SVCNAME"
+}
+
+runit_stop()
+{
+ local service_path service_link
+ service_path="${runit_service:-/etc/sv/${RC_SVCNAME}}"
+ if [ ! -d "${service_path}" ]; then
+ eerror "Runit service ${service_path} not found"
+ return 1
+ fi
+ service_link="${RC_SVCDIR}/sv/${service_path##*/}"
+ ebegin "Stopping ${name:-$RC_SVCNAME}"
+ sv stop "${service_link}" > /dev/null 2>&1 &&
+ rm "${service_link}"
+ eend $? "Failed to stop $RC_SVCNAME"
+}
+
+runit_status()
+{
+ local service_path service_link
+ service_path="${runit_service:-/etc/sv/${RC_SVCNAME}}"
+ if [ ! -d "${service_path}" ]; then
+ eerror "Runit service ${service_path} not found"
+ return 1
+ fi
+ service_link="${RC_SVCDIR}/sv/${service_path##*/}"
+ sv status "${service_link}"
+}